<?php
/*
Plugin Name:  Photos from one year ago
Version: 0.1.beta2
Description: Add a "photos from one year ago" link in "Specials" menu.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=893
Author: ddtddt
Author URI: http://temmii.com/piwigo/
*/

// +-----------------------------------------------------------------------+
// | Photos from one year ago for Piwigo by TEMMII                         |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2020 ddtddt               http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');

define('PFOYA_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

add_event_handler('loading_lang', 'pfoya_loading_lang');	  
function pfoya_loading_lang(){
  load_language('plugin.lang', PFOYA_PATH);
}


  add_event_handler('blockmanager_apply' , 'add_link_pfoya');
  add_event_handler('loc_end_section_init', 'section_init_pfoya');
  
  function add_link_pfoya($menu_ref_arr){
    global $conf;
    $menu = &$menu_ref_arr[0];
    $position = (isset($conf['pfoya_position']) and is_numeric($conf['pfoya_position'])) ? $conf['pfoya_position'] : 5;
    if (($block = $menu->get_block('mbSpecials')) != null){
     array_splice($block->data, $position-1, 0, array('photos_from_one_year_ago' =>
      array(
        'URL' => make_index_url(array('section' => 'photos_from_one_year_ago')),
        'TITLE' => l10n('Displays photos from one year ago'),
        'NAME' => l10n('Photos from one year ago')
        )
      )
    );
   }
  }

function section_init_pfoya()
{
  global $tokens, $page, $conf;
  
  if (!in_array('photos_from_one_year_ago', $tokens))
  {
    return;
  }
  
  $page['section'] = 'photos_from_one_year_ago';
  $page['title'] = '<a href="' . duplicate_index_url() . '">' . l10n('Photos from one year ago') . '</a>';
  $page['section_title'] = '<a href="'.get_gallery_home_url().'">' . l10n('Home') . '</a>'
    . $conf['level_separator'] . $page['title'];

  $query = '
SELECT DISTINCT image_id
    FROM ' . IMAGE_CATEGORY_TABLE . '
    WHERE ' .  
      get_sql_condition_FandF(
        array(
          'forbidden_categories' => 'category_id',
          'visible_categories' => 'category_id',
          'visible_images' => 'image_id',
          ),
        '', true
        )
    . '
;';

  $img = query2array($query, null, 'image_id');

  if (empty($img))
  {
    $page['items'] = array();
  }
  else
  {
	$datepfoya = (isset($conf['pfoya_dateb'])) ? $conf['pfoya_dateb'] : "date_available";
	$daydate= (isset($conf['pfoya_date'])) ? $conf['pfoya_date'] : date("Y-m-d", strtotime('-1 year'));
    $query = 'SELECT id,date_available FROM ' . IMAGES_TABLE . ' AS img WHERE img.id IN (' . implode(',', $img) . ') and DATE('.$datepfoya.') ="'.$daydate.'"';
    $page['items'] = query2array($query, null, 'id');
    
  add_event_handler('loc_end_index_thumbnails', 'add_nb_pfoya');
}

function add_nb_pfoya($tpl_thumbnails_var){
  global $template, $user, $selection;

  // unsed sort order
  $template->clear_assign('image_orders');

    $query = 'SELECT id, date_available FROM '.IMAGES_TABLE.' WHERE id IN ('.implode(',', $selection).');';
    $nb_download = query2array($query, 'id', 'date_available');
    
    foreach ($tpl_thumbnails_var as &$row)
    {
      $row['date_available'] = $nb_download[$row['id']];
    }
    unset($row);
  

  return $tpl_thumbnails_var;
}



  
}







   





